SystemOrganization addCategory: #'Pier-OmniBrowser-Core'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Nodes'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Actors'!

!OBMetagraph methodsFor: '*pier-omnibrowser' stamp: 'lr 11/17/2005 18:21'!
pier
	| root kernel structure description |
	root := OBMetaNode named: 'Root'.
	kernel := OBMetaNode named: 'Kernel'.
	structure := OBMetaNode named: 'Structure'.
	description := OBMetaNode named: 'Description'.
	root 
		childAt: #children put: kernel.
	kernel
		childAt: #children put: structure;
		addActor: PRInspectActor new.
	structure 
		childAt: #children put: structure;
		childAt: #description put: description;
		addActor: (PRContextActor new
			add: PREditCommand;
			add: PRAddCommand;
			add: PRRemoveCommand;
			add: PRMoveCommand;
			add: PRCopyCommand;
			yourself);
		addActor: PRInspectActor new;
		filterClass: OBModalFilter.
	description
		childAt: #children put: description;
		childAt: #description put: description;
		addActor: PRInspectActor new;
		filterClass: OBModalFilter.
	^ root.! !

OBBrowser subclass: #PRPierBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/17/2005 14:44'!
defaultMetagraph
	^ #pier! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/17/2005 15:36'!
defaultRootNode
	^ PRRootNode new.! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 11/17/2005 18:22'!
initialize
	self registerInToolsFlap; registerInWorldMenu.! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/1/2005 23:11'!
optionalButtons
	^ #( 'edit' 'add'  'remove' 'move' 'copy' ).! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 11/17/2005 18:19'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( PRPierBrowser open 'Pier Browser' 'A browser to inspect your pier environment and its meta-descriptions.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 11/17/2005 14:42'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'Pier Browser' 
			with: (Array
				with: self
				with: #open)) ].! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/17/2005 14:42'!
title
	^ 'Pier Browser'! !

!PRPierBrowser methodsFor: 'morphic' stamp: 'lr 4/17/2005 11:59'!
defaultBackgroundColor
	^ Color r: 0.151 g: 0.327 b: 0.720.! !

!PRPierBrowser methodsFor: 'morphic' stamp: 'lr 4/25/2005 08:44'!
defaultLabel
	^ super defaultLabel , ': ' , self root name.! !

MAElementMorph subclass: #PRStructureMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureMorph methodsFor: 'private' stamp: 'lr 11/14/2005 21:05'!
buildMorphEditor
	^ (SimpleHierarchicalListMorph
		on: self
		list: #root
		selected: #selected
		changeSelected: #selected:
		menu: nil
		keystroke: nil)
			hResizing: #spaceFill;
			borderColor: #inset;
			borderWidth: 2;
			expandAll;
			yourself.! !

!PRStructureMorph methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:09'!
root
	^ Array with: (PRStructureItemWrapper with: self model context root).! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:09'!
selected
	^ PRStructureItemWrapper with: self value.! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 11/14/2005 20:55'!
selected: aWrapper
	self value: (aWrapper ifNotNil: [ aWrapper item ]).
	self changed: #selected.! !

OBNode subclass: #PRWikiNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

PRWikiNode subclass: #PRDescriptionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRDescriptionNode methodsFor: 'accessing' stamp: 'lr 4/26/2005 20:49'!
children
	^ Array streamContents: [ :stream |
		self model hasChildren ifTrue: [
			self model do: [ :each |
				stream nextPut: (self class on: each) ] ] ].! !

!PRDescriptionNode methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
name
	^ self model label.! !

PRWikiNode subclass: #PRKernelNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 11/17/2005 15:55'!
children
	^ Array with: (PRStructureNode on: self model root).! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 4/25/2005 08:40'!
name
	^ self model name.! !

PRWikiNode subclass: #PRRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRRootNode methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:06'!
children
	^ self model asArray collect: [ :each | PRKernelNode on: each ].! !

!PRRootNode methodsFor: 'initialization' stamp: 'lr 11/17/2005 16:06'!
initialize
	super initialize.
	self setModel: PRKernel instances.! !

!PRRootNode methodsFor: 'accessing' stamp: 'lr 11/14/2005 20:10'!
name
	^ 'Kernel'! !

PRWikiNode subclass: #PRStructureNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 11/1/2005 21:59'!
children
	^ Array streamContents: [ :stream |
		self model hasChildren ifTrue: [
			self model childrenDo: [ :each |
				stream nextPut: (self class on: each) ] ] ].! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:09'!
context
	^ context ifNil: [
		context := PRContext 
			kernel: self model kernel
			structure: self model ].! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 4/25/2005 09:10'!
kernel
	^ self context kernel.! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:59'!
name
	^ self model title.! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
text
	^ (self model respondsTo: #contents)
		ifTrue: [ self model contents ]
		ifFalse: [ super text ].! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 12/21/2005 19:51'!
text: aString
	| command |
	command := self model editCommandClass new.
	(command respondsTo: #contents)
		ifFalse: [ ^ super text: aString ].
	self context command: command.
	command contents: aString; execute.
	^ true.! !

!PRWikiNode class methodsFor: 'instance creation' stamp: 'lr 4/25/2005 23:48'!
on: aModel
	^ self new
		setModel: aModel;
		yourself.! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 4/26/2005 20:49'!
children
	^ Array new.! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 11/17/2005 15:36'!
description
	^ Array with: (PRDescriptionNode on: self model description).! !

!PRWikiNode methodsFor: 'comparing' stamp: 'lr 4/25/2005 23:58'!
hash
	^ self model hash.! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
model
	^ model! !

!PRWikiNode methodsFor: 'initialization' stamp: 'lr 4/25/2005 23:08'!
setModel: aModel
	model := aModel! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 11/14/2005 20:19'!
text
	^ self model printString.! !

!PRWikiNode methodsFor: 'comparing' stamp: 'lr 4/25/2005 23:58'!
= anObject
	^ self species = anObject species
		and: [ self model = anObject model ].! !

ListItemWrapper subclass: #PRStructureItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureItemWrapper methodsFor: 'converting' stamp: 'lr 11/14/2005 20:58'!
asString
	^ self item title.! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 11/1/2005 22:57'!
contents
	^ self item children collect: [ :each | self class with: each ].! !

!PRStructureItemWrapper methodsFor: 'testing' stamp: 'lr 4/25/2005 22:39'!
hasContents
	^ self item hasChildren.! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 11/14/2005 20:57'!
hash
	^ self item hash.! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 4/25/2005 22:38'!
item
	^ item! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 11/14/2005 20:57'!
= anObject
	^ self species = anObject species
		and: [ self item = anObject item ].! !

OBActor subclass: #PRContextActor
	instanceVariableNames: 'commandClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Actors'!

!PRContextActor methodsFor: 'public' stamp: 'lr 10/29/2005 21:58'!
actionForCommand: aClass in: aNode
	^ OBAction
		label: aClass label , '...'
		buttonLabel: aClass label asLowercase
		receiver: self selector: #show:
		arguments: (Array with: (aClass 
			context: aNode context)).! !

!PRContextActor methodsFor: 'public' stamp: 'lr 4/26/2005 21:30'!
actionsForNode: aNode
	| command |
	^ Array streamContents: [ :stream |
		aNode context allCommandClasses in: [ :commands |
			self commandClasses do: [ :class |
				command := commands
					detect: [ :each | 
						each = class
							or: [ each inheritsFrom: class ] ]
					ifNone: [ nil ].
				command isNil ifFalse: [ 
					stream nextPut: (self 
						actionForCommand: command
						in: aNode) ] ] ] ].! !

!PRContextActor methodsFor: 'accessing' stamp: 'lr 4/26/2005 21:27'!
add: aClass
	self commandClasses add: aClass.! !

!PRContextActor methodsFor: 'accessing' stamp: 'lr 4/26/2005 21:27'!
commandClasses
	^ commandClasses ifNil: [ commandClasses := OrderedCollection new ]. ! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 7/8/2005 10:40'!
execute: aCommand
	aCommand isNil
		ifTrue: [ ^ self ].
	aCommand execute.
	aCommand answer command isView
		ifFalse: [ ^ self show: aCommand answer command ].
! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 12/20/2005 13:54'!
show: aCommand
	| result |
	result := aCommand isQuick
		ifTrue: [ aCommand ]
		ifFalse: [
			PRCurrentContext
				use: aCommand
				during: [
					aCommand asMorph
						addButtons; 
						addWindow;
						callInWorld ] ].
	result notNil
		ifTrue: [ self execute: result ].! !

OBActor subclass: #PRInspectActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Actors'!

!PRInspectActor methodsFor: 'accessing' stamp: 'lr 4/26/2005 21:18'!
actionsForNode: aClassNode
	^ Array 
		with: (OBAction
			label: 'inspect'
			buttonLabel: String new
			receiver: aClassNode model
			selector: #inspect
			arguments: Array new)
		with: (OBAction
			label: 'explore'
			buttonLabel: String new
			receiver: aClassNode model
			selector: #explore
			arguments: Array new).! !
PRPierBrowser initialize!
